import { __makeTemplateObject } from 'tslib';
import { Directive, ElementRef, Renderer2, Input, NgModule } from '@angular/core';
import { Location, LocationStrategy, PathLocationStrategy } from '@angular/common';
import { isUndefined, isString } from 'util';
import { NavigationStart, NavigationEnd, Router } from '@angular/router';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxRouteHighlighterConfig = /** @class */ (function () {
    function NgxRouteHighlighterConfig(config) {
        this.config = config;
    }
    /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    NgxRouteHighlighterConfig.prototype.getNormalConfig = /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    function (url, className) {
        this.config = {
            className: className ? className : 'active',
            links: url,
            strict: false
        };
        return new NgxRouteHighlighterConfig(this.config);
    };
    /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    NgxRouteHighlighterConfig.prototype.getStrictConfig = /**
     * @param {?} url
     * @param {?=} className
     * @return {?}
     */
    function (url, className) {
        this.config = {
            className: className ? className : 'active',
            links: url,
            strict: true
        };
        return new NgxRouteHighlighterConfig(this.config);
    };
    return NgxRouteHighlighterConfig;
}());
if (false) {
    /** @type {?} */
    NgxRouteHighlighterConfig.prototype.config;
}
/**
 * @record
 */
function LinksEntity() { }
if (false) {
    /** @type {?} */
    LinksEntity.prototype.links;
    /** @type {?} */
    LinksEntity.prototype.className;
    /** @type {?|undefined} */
    LinksEntity.prototype.strict;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RouteHighlighterDirective = /** @class */ (function () {
    function RouteHighlighterDirective(el, location, r2, router) {
        var _this = this;
        this.el = el;
        this.location = location;
        this.r2 = r2;
        this.router = router;
        this.defaultConfig = {
            className: 'active',
            links: null,
            strict: false
        };
        this.ngxRouteHighlighter = new NgxRouteHighlighterConfig(this.defaultConfig);
        this.activeClass = 'active';
        // console.clear();
        router.events.subscribe((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event instanceof NavigationStart) {
                _this.r2.removeClass(_this.el.nativeElement, _this.activeClass);
            }
            else if (event instanceof NavigationEnd) {
                _this.setClass();
            }
        }));
    }
    /**
     * @return {?}
     */
    RouteHighlighterDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.ngxRouteHighlighter = new NgxRouteHighlighterConfig(this.defaultConfig);
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    RouteHighlighterDirective.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (!isUndefined(changes.ngxRouteHighlighter.currentValue)) {
            this.ngxRouteHighlighter = changes.ngxRouteHighlighter.currentValue;
        }
        if (this.ngxRouteHighlighter.config) {
            this.activeClass = this.ngxRouteHighlighter.config.className ? this.ngxRouteHighlighter.config.className : 'active';
        }
        else {
            this.activeClass = 'active';
        }
    };
    /**
     * @return {?}
     */
    RouteHighlighterDirective.prototype.setClass = /**
     * @return {?}
     */
    function () {
        if (this.linkMatcher(this.ngxRouteHighlighter.config.links, this.ngxRouteHighlighter.config.strict)) {
            this.r2.addClass(this.el.nativeElement, this.activeClass);
        }
    };
    /**
     * @param {?} links
     * @param {?=} strict
     * @return {?}
     */
    RouteHighlighterDirective.prototype.linkMatcher = /**
     * @param {?} links
     * @param {?=} strict
     * @return {?}
     */
    function (links, strict) {
        var _this = this;
        /** @type {?} */
        var foundMatch = [];
        if (!strict) {
            strict = false;
        }
        else {
            console.warn('strict is dapricated it will not have any effect as of now and it will be removed after version 0.1.0');
        }
        if (isString(links)) {
            links = [links];
        }
        if (links) {
            links.forEach((/**
             * @param {?} link
             * @param {?} index
             * @return {?}
             */
            function (link, index) {
                /** @type {?} */
                var $r = _this.regExpGen(link);
                foundMatch.push($r.test(_this.location.path()));
            }));
        }
        // console.log(foundMatch);
        return foundMatch.indexOf(true) !== -1;
    };
    /**
     * @param {?} link
     * @return {?}
     */
    RouteHighlighterDirective.prototype.regExpGen = /**
     * @param {?} link
     * @return {?}
     */
    function (link) {
        /** @type {?} */
        var ragexBaseString = link.replace(new RegExp(/(\/\*)/, 'gmi'), '\/[a-z0-9]+');
        return new RegExp(String.raw(templateObject_1 || (templateObject_1 = __makeTemplateObject(["(", ")"], ["(", ")"])), ragexBaseString), 'gmi');
    };
    RouteHighlighterDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxRouteHighlighter]',
                    providers: [Location, { provide: LocationStrategy, useClass: PathLocationStrategy }],
                },] }
    ];
    /** @nocollapse */
    RouteHighlighterDirective.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Location },
        { type: Renderer2 },
        { type: Router }
    ]; };
    RouteHighlighterDirective.propDecorators = {
        ngxRouteHighlighter: [{ type: Input }],
        activeClass: [{ type: Input }]
    };
    return RouteHighlighterDirective;
}());
if (false) {
    /** @type {?} */
    RouteHighlighterDirective.prototype.defaultConfig;
    /** @type {?} */
    RouteHighlighterDirective.prototype.ngxRouteHighlighter;
    /** @type {?} */
    RouteHighlighterDirective.prototype.activeClass;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.location;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.r2;
    /**
     * @type {?}
     * @private
     */
    RouteHighlighterDirective.prototype.router;
}
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxRouteHighlighterModule = /** @class */ (function () {
    function NgxRouteHighlighterModule() {
    }
    /**
     * @param {?} router
     * @return {?}
     */
    NgxRouteHighlighterModule.forRoot = /**
     * @param {?} router
     * @return {?}
     */
    function (router) {
        return {
            ngModule: NgxRouteHighlighterModule,
            imports: [
                router,
            ]
        };
    };
    NgxRouteHighlighterModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [RouteHighlighterDirective],
                    imports: [],
                    exports: [RouteHighlighterDirective],
                },] }
    ];
    return NgxRouteHighlighterModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxRouteHighlighterConfig, NgxRouteHighlighterModule, RouteHighlighterDirective };
//# sourceMappingURL=ngx-route-highlighter.js.map
